#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jun  1 16:42:25 2020

@author: davidworrall
version 0.00 (working)
date: 2020 0606
NB: In the download dataset deaths_pivot.csv it was necessary to adjust
  "Korea,South" to  Korea_Souththe to avoid foramtting errors
"""

import csv
directory="/Users/davidworrall/Documents/RESEARCH/COVID-19/"
fname= "deaths_pivot.csv" 
#with open('/Users/davidworrall/Documents/CCC/TEACHING/TeachingResources_DSon/LiteracyRatesGlobalLongRun.csv', newline='') as csvfile:
with open(directory+fname, newline='') as csvfile:
    ipdata = csv.reader(csvfile, delimiter=',', quotechar='"')
    dataRead = []
    for row in ipdata:
        dataRead += [[','.join(row)]]
for indx in range (1,len(dataRead)):
    dataRead[indx] = dataRead[indx][0].split(',')
"""
    if result[indx][3] == '':                               # blank zip code
        result[indx][3] = 999999                            # NYCity zip code missing from for data set
    for i in range(3,6):
        result[indx][i] = int (result[indx][i])
"""
dataRead[0] = dataRead[0][0].split(',')                         # put col names in same format as other

#dateList = []
#dateDict={}
countryDict = {}

for entry in dataRead:
    if entry[0] not in countryDict.keys():
        countryDict[entry[0]] = [entry[1:]]             # key is country, entry is [date, nrDeaths]
    else:
        countryDict[entry[0]] = countryDict[entry[0]] + [entry[1:]]     # append date data to country key
print ("Countries covered in this conversion:\n", countryDict.keys())

#for kee in countryDict.keys():  print (kee, countryDict[kee])

dateDict = {}           # a date dictionary, one entry per date. value is [country,nrDeaths]
                        # used, below to recover nrDeaths for each date for each country
for entry in dataRead:
    if entry[1] not in dateDict.keys():
        dateDict[entry[1]] = [entry[0], entry[2]]   # [countrt, nrDeaths]
    else:
        dateDict[entry[1]] = dateDict[entry[1]] + [entry[0], entry[2]]     # append date data to country key

#for kee in dateDict.keys():  print (kee, dateDict[kee], "\n")
dateList = []
for kee in dateDict.keys():
    dateList += [kee]
dateList = dateList[1:]   # drop the 0th item - the term 'date''
print ("Dates covered in this conversion:\n", dateList)


# Convert data to csv format where each rew is in form countryName,nrDeathsDay1,nrDeathsDay2,nrDeathsDay3,
# format is adjusted to fit with deaths_global database which includes lat+long etc
with open("deaths_pivot_drwRotated.csv", 'w', newline='\n') as myfile:
    myfile.write (",,,")                            # to fit with deaths_global database which includes lat+long etc
    for datee in dateDict.keys():                   # write each date covered, one date per colum
        myfile.write (datee.strip("'") + ',')         
    myfile.write ("\n")
    for country in countryDict.keys():                  # for each country
        if country != 'country':                        # avoid the heading
            tmpRow = ","+country.strip("'")+"_pvt,,"    # to fit with deaths_global database. _pvt=pivot to ID this dataset
            for i in range (len (dateDict.keys())-1):
                tmpRow += ","+ countryDict[country][i][1]    # deaths
#            print (tmpRow)
            myfile.write(tmpRow+'\n')
            tmpRow = ""
myfile.close()
